--[[
Project name: DkpBidder
Developed by: Eadel
Website: http://www.arthion.fr/aldea
Description: DKP ingame management
License: All Rights Reserved unless otherwise explicitly stated. 
File: DKPBidder.lua
File description: Core
]]

local bidders = {};
local DKPBidder_incombat;
local PREFIX = "DkpBidder : "
local Hidewhisps = true
DKPBidder= LibStub("AceAddon-3.0"):NewAddon("DKPBidder","AceHook-3.0","AceConsole-3.0","AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("DKPBidder", true)
local options = {
    name = "DKPBidder",
    handler = DKPBidder,
    type = 'group',
    args = {
				toggle = {
					type = 'toggle',
					name = L["Enable"],
					desc = L["Enable DKPBidder"],
					get = function(info)
							return DKPBidder:IsEnabled()
						end,
					set = function(info, value)
							--module.db.profile.enabled = not not value
							if value then
								return DKPBidder:Enable()
							else
								return DKPBidder:Disable()
							end
						end,
					order = 1
				},
				
				Whisper = {
					type = 'toggle',
					name = L["Show whispers"],
					desc = L["Show/Hide whispers"],
					order = 2,
					get = function() 
						if Hidewhisps then
							print (L["Whisps filter is off"])
						else
							print (L["Whisps filter is on"])
						end
						return Hidewhisps end,
					set = function(info, value)
						Hidewhisps = not Hidewhisps
					end,
				},
			},
}
LibStub("AceConfig-3.0"):RegisterOptionsTable("DKPBidder", options, {"dkpbidder"})


	StaticPopupDialogs["DKPBIDDER_PRINT_LIST"] = {
  		text = L["Print list"],
  		button1 = L["Yes"], 
  		button2 = L["No"], 
  		OnAccept				=	function(self)
										DKPBidder:printBidders()
									end,
		OnCancel				=	function(self)
									end,
  		timeout = 0,
  		whileDead = 1,
  		hideOnEscape = 1 -- quitter
	};
	
		StaticPopupDialogs["DKPBIDDER_CLEAR_LIST"] = {
  		text = L["Clear list"],
  		button1 = L["Yes"], 
  		button2 = L["No"], 
  		OnAccept				=	function(self)
										DKPBidder:wipeBidders()
									end,
		OnCancel				=	function(self)
										
									end,
  		timeout = 0,
  		whileDead = 1,
  		hideOnEscape = 1 -- quitter
	};

--Loading addon
function DKPBidder:OnInitialize()	
--DKPBidder:RegisterChatCommand("dkpbidder", "SlashCommand")
DKPBidder:RegisterChatCommand("dkp", "SlashCommand")
self.db = LibStub("AceDB-3.0"):New("DKPBidderDB")
end


--Enabling addon
function DKPBidder:OnEnable()	
		DKPBidder:RegisterEvent("CHAT_MSG_WHISPER");
		DKPBidder:RegisterEvent("CHAT_MSG_RAID","eventHandler");
		DKPBidder:RegisterEvent("CHAT_MSG_RAID_LEADER","eventHandler");
		--DKPBidder:RegisterEvent("CHAT_MSG_CHANNEL","eventHandler");
		DKPBidder:RegisterEvent("PLAYER_REGEN_DISABLED");
		DKPBidder:RegisterEvent("PLAYER_REGEN_ENABLED");
		ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", BlockIncomingChatFrame)
		ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", BlockOutgoingChatFrame)
		if (HeadCount) then
			DKPBidder:Hook(HeadCount,"lootManagementUpdate", "HeadcountHook", true)
		end
		print(L["addon.init"])
		self.db.global.DkpInfo = {timestamp="0"}
		print(self.db.global.DkpInfo.timestamp)
		
		if DKPInfo then
			if (DKPInfo.timestamp > self.db.global.DkpInfo.timestamp)  then
				--print (L["DB.compare"]..DKPInfo.date..L["DB.compare2"]..self.db.global.DkpInfo.date)
				print(L["DB.updating"])
				self.db.global.DkpInfo = DKPInfo
				self.db.global.DkpData = gdkp
			else 
				print (L["DB.uptodate"])
			end
			-- clearing memory of useless ressources
			--wipe(DKPInfo)
			--wipe(gdkp)
			wipe(DKP_ITEMS)
			wipe(GetDKPRaidPlaner)
		else
			print (L["DKPlist missing"])
			DKPBidder:Disable()
		end
end

function DKPBidder:OnDisable()	
	if DKPBidder:IsHooked(HeadCount,"lootManagementUpdate") then
		DKPBidder:Unhook(HeadCount,"lootManagementUpdate")
	end
	print (L["Addon Disabled"])
end

function DKPBidder:SlashCommand(input)
	_args = GetArgs(input, " ");	
	if (input == "print") then
			DKPBidder:printBidders();
	elseif (input == "clear") then
		DKPBidder:wipeBidders()
	  elseif (_args[1] == "add") then
		if (_args[2]==nil or _args[3]==nil) then
			print(L["AddManual"])
		else
			if DKPBidder:playerExists(_args[2]) then
				if (tonumber(_args[3])==nil) then
					print(L["NotANumber"])
				else
					DKPBidder:DKP_Add(_args[2].." ".._args[3])
				end
			else
				print(_args[2]..L["notinroster"])
			end
		end
		
	elseif (_args[1] == "minus") then
		if (_args[2]==nil or _args[3]==nil) then
			print(L["SubManual"])
		else
			if DKPBidder:playerExists(_args[2]) then
				if (tonumber(_args[3])==nil) then
					print(L["NotANumber"])
				else
					DKPBidder:DKP_Sub(_args[2].." ".._args[3])
				end
			else
				print(_args[2]..L["notinroster"])
			end
		end
	  
	else
		print (L["Addon.usage"]) 
		print (L["addon.usage2"]) 
		print (L["addon.usage3"]) 
		print (L["addon.usage4"]) 
	end
end

-- Event Handler
function DKPBidder:eventHandler(event)
	
	
	-- Detect +1 in raid or raid leader chan, add bidder un bidder list
	if (event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER") then
		
		_args = GetArgs(arg1, " ");	
		
		if DKPBidder_incombat == false then
				local sName, sLink, iRarity = GetItemInfo(arg1)
				if (iRarity==4) then
					StaticPopup_Show("DKPBIDDER_CLEAR_LIST")
				end
		end
		
		if ((_args[1] == "+1")) then
			
				table.insert(bidders, arg2);
				for index,value in ipairs(bidders) do 
					print(index.." : "..value);
				end;
				StaticPopup_Show("DKPBIDDER_PRINT_LIST")
		end;
  	end;
end

function  DKPBidder:CHAT_MSG_WHISPER()
		
		_args = GetArgs(arg1, " ");

		if (_args[1] == "dkp") then
			if (_args[2] ~= nil) then
				if(DKPBidder:playerExists(_args[2])) then
					SendChatMessage(PREFIX..L["points.of"].._args[2].." : "..DKPBidder:grabDkp(_args[2]).." dkp.", "WHISPER", this.language, arg2);
				else 
					SendChatMessage(PREFIX.._args[2]..L["notinroster"],  "WHISPER", this.language, arg2);
				end
			elseif(DKPBidder:playerExists(arg2)) then
				SendChatMessage(PREFIX..L["your.points"]..DKPBidder:grabDkp(arg2).." dkp.", "WHISPER", this.language, arg2);
			else 
				SendChatMessage(PREFIX..L["younotinroster"],  "WHISPER", this.language, arg2);
				
			
			end;
		end;
		
		if (_args[1] == "clear") then
			DKPBidder:wipeBidders()
		end;
		
		if (_args[1] == "print") then

			DKPBidder:printBidders();

		end; -- end of stop cond
		
		
end; -- end of whisper event

function DKPBidder:PLAYER_REGEN_DISABLED()
	DKPBidder_incombat = true
end

function DKPBidder:PLAYER_REGEN_ENABLED()
	DKPBidder_incombat = false
end

function GetArgs(message, separator)
	if (message == nil) then
		return;
	end;
	-- Declare 'args' variable.
	local args = {};

	-- Declare 'i' integer.
	i = 0;

	-- Search for seperators in the string and return
	-- the separated data.
	
	for value in string.gmatch(message, "[^"..separator.."]+") do
		i = i + 1;
		args[i] = value;
	end -- end for

	-- Submit the filtered data.
	return args;
end -- end GetArgs()

function DKPBidder:printBidders()
			--table.sort(bidders)
			local winner
			local winnerpoints=0
			for index,value in ipairs(bidders) do 
				if(DKPBidder:playerExists(value)) then
					SendChatMessage(index..L["points.of"]..value.." : "..DKPBidder:grabDkp(value).." dkp.", "RAID", this.language);
					if DKPBidder:grabDkp(value) > winnerpoints then
						winner = tostring(value)
						winnerpoints=DKPBidder:grabDkp(value)
					end
				else
					SendChatMessage(index..". "..arg2..L["notinroster"], "RAID", this.language);
				end
			end;
			SendChatMessage(L["The winner is"]..tostring(winner).." !", "RAID", this.language);
			DKPBidder:wipeBidders()
end

function DKPBidder:wipeBidders()
	wipe(bidders);
	print(L["BiddersCleared"])
end


function DKPBidder:DKP_Sub(msg)
	DKPBidder:MATH_DKP(msg,"sub");
end;

function DKPBidder:DKP_Add(msg)
	DKPBidder:MATH_DKP(msg,"add");
end;

function DKPBidder:MATH_DKP(msg,_type)
	_args = GetArgs(msg, " ");
	
	if _type == "add" then
						self.db.global.DkpData.players[_args[1]]["dkp_current"] = self.db.global.DkpData.players[_args[1]]["dkp_current"] + _args[2] ;
						DKPBidder:RaidDisplay("<DKP>".._args[1]..L["win"].._args[2].." dkp");

	elseif _type == "sub" then
						self.db.global.DkpData.players[_args[1]]["dkp_current"] = self.db.global.DkpData.players[_args[1]]["dkp_current"] - _args[2] ;
						DKPBidder:RaidDisplay("<DKP>".._args[1]..L["loose"].._args[2].." dkp");
	end;	
end;

-- Hook with headcount
function DKPBidder:HeadcountHook(Addon,raidId, lootId, playerName, source, lootCost, lootNote)
 DKPBidder:DKP_Sub(playerName.." "..lootCost)
end

function DKPBidder:grabDkp(player)
--print(self.db.global.DkpData.players[player]["dkp_current"])
return self.db.global.DkpData.players[player]["dkp_current"]
end

function DKPBidder:playerExists(player)
	if (self.db.global.DkpData.players[player]~=nil) then
		return true
	else
		return false
	end
end


function DKPBidder:RaidDisplay(text)
	if UnitInRaid("player") then
		SendChatMessage(text, "RAID", this.language);
	else
		print (text)
	end
end

function BlockIncomingChatFrame(msg)
	if (Hidewhisps) then
		local locmsg = strlower(arg1);
		local startPos, endPos, firstWord, restOfString;
			startPos, endPos, firstWord, restOfString = strfind(locmsg, "dkp");
			if (locmsg == "dkp") then
				return true;
			elseif ((startPos == 1) and (endPos == 3)) then
				return true;
			end;
	return false;
		end
	return false
end
function BlockOutgoingChatFrame(msg)
	if (Hidewhisps) then
		local locmsg = strlower(arg1);
		startPos, endPos, firstWord, restOfString = string.find(locmsg, strlower(PREFIX));
			if (startPos==1) then
				return true;
			end;
		return false;
	end
	return false
end
